-----------------------------------------------------------------------------------------------
-- Client Lua Script for EasyReload
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- EasyReload Module Definition
-----------------------------------------------------------------------------------------------
local EasyReload = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function EasyReload:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function EasyReload:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- EasyReload OnLoad
-----------------------------------------------------------------------------------------------
function EasyReload:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("EasyReload.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- EasyReload OnDocLoaded
-----------------------------------------------------------------------------------------------
function EasyReload:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "EasyReloadForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("rl", "OnEasyReloadOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- EasyReload Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/rl"
function EasyReload:OnEasyReloadOn()
	RequestReloadUI() -- show the window

end

-----------------------------------------------------------------------------------------------
-- EasyReloadForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function EasyReload:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function EasyReload:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- EasyReload Instance
-----------------------------------------------------------------------------------------------
local EasyReloadInst = EasyReload:new()
EasyReloadInst:Init()

